#include <errno.h>
#include <fcntl.h>
#include <signal.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <unistd.h>

#define BUF_SIZE 1024


int fd;
const char *pipe_path = "/tmp/osp_pipe";


void die(const char *msg)
{
  if (msg)
    perror(msg);

  close(fd);

  exit(EXIT_FAILURE);
}


void handle_sig(const int signo)
{
  if (signo == SIGINT)
    die("\n");
}


int main(void)
{
  int res;
  char buf[BUF_SIZE];


  if (signal(SIGINT, handle_sig) == SIG_ERR)
    die("Couldn't register custom signal handler\n");


  fd = open(pipe_path, O_RDONLY);
  if (fd == -1)
    die("Couldn't open pipe");


  res = read(fd, buf, BUF_SIZE);
  if (res == -1)
    die("Couldn't read from pipe");


  res = close(fd);
  if (res == -1)
    die("Couldn't close pipe");


  buf[BUF_SIZE-1] = '\0';
  printf("%s", buf);
  fflush(stdout);

  close(fd);

  return EXIT_SUCCESS;
}
