#include <errno.h>
#include <fcntl.h>
#include <signal.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <unistd.h>


int fd;
const char *pipe_path = "/tmp/osp_pipe";


void die(const char *msg)
{
  if (msg)
    perror(msg);

  close(fd);
  unlink(pipe_path);

  exit(EXIT_FAILURE);
}


void handle_sig(const int signo)
{
  if (signo == SIGINT)
    die("\n");
}


int main(void)
{
  int res;
  char msg[] = "Hi\n";


  if (signal(SIGINT, handle_sig) == SIG_ERR)
    die("Couldn't register custom signal handler\n");


  res = mkfifo(pipe_path, 0666);
  if (res == -1)
    die("Couldn't create pipe");


  fd = open(pipe_path, O_WRONLY);
  if (fd == -1)
    die("Couldn't open pipe");


  res = write(fd, msg, sizeof(msg));
  if (res == -1)
    die("Couldn't write to pipe");


  res = close(fd);
  if (res == -1)
    die("Couldn't close pipe");


  res = unlink(pipe_path);
  if (res == -1)
    die("Coudln't remove pipe");


  close(fd);
  unlink(pipe_path);

  return EXIT_SUCCESS;
}

